Ruby - Feature #6811

File, Dir and FileUtils should have bang-versions of singleton methods that fails silently
07/29/2012 08:34 PM - prijutme4ty (llya Vorontsov)
Description

| found that often write

Dir.mkdir(folder) unless Dir.exist? folder

and similar code for rm, rm_rf and so on

We can simply make bang-versions like

def Dir.mkdir!(folder, permissions=0744)
Dir.mkdir(folder, permissions) unless Dir.exist? folder

or another alternative Dir.mkdir(folder, permissions) rescue false

end

History

#1 - 07/29/2012 10:32 PM - trans (Thomas Sawyer)

At least for mkdir you can use mkdir_p, although it annoyingly warns about missing path if $VERBOSE-=true (can we consider that a bug please?).

#2 - 07/30/2012 12:26 AM - Eregon (Benoit Daloze)

prijutmed4ty (llya Vorontsov) wrote:

| found that often write
Dir.mkdir(folder) unless Dir.exist? folder
and similar code for rm, rm_rf and so on

Bang methods are not usually used for that in Ruby core and stdlib.
| agree for the practical point of view of this though.
I'm unsure what a good name would be.

Using mkdir_p for this seems a bit dangerous, as it might create intermediary directories you did not intend to.
trans wrote:

although it annoyingly warns about missing path if $VERBOSE=true (can we consider that a bug please?).
How so?

#3 - 07/30/2012 03:07 AM - trans (Thomas Sawyer)
=begin
Sorry, it is if SDEBUG = true, not $VERBOSE.

Here's the issue:

FileUtils.mkdir_p(‘a/b/c/d")

Exception Errno::ENOENT' at /home/trans/.local/lib/ry/rubies/1.9.3-p125/lib/ruby/1.9.1/fileutils.rb:247 - No such file or directory - a/b/c/d
Exception Errno::EEXIST' at /home/trans/.local/lib/ry/rubies/1.9.3-p125/lib/ruby/1.9.1/fileutils.rb:247 - File exists - .

=> ["a/b/c/d"]

It the most annoying warning, and | always end-up writing my own method instead.
=end

#4 - 07/30/2012 03:29 AM - Eregon (Benoit Daloze)
On 29 July 2012 20:07, trans (Thomas Sawyer) transfire@gmail.com wrote:
Sorry, it is if SDEBUG = true, not $VERBOSE.
Here's the issue:

FileUtils.mkdir_p(‘a/b/c/d")

Exception Errno::ENOENT' at /home/trans/.local/lib/ry/rubies/1.9.3-p125/lib/ruby/1.9.1/fileutils.rb:247 - No such file or directory - a/b/c/d
Exception Errno::EEXIST' at /home/trans/.local/lib/ry/rubies/1.9.3-p125/lib/ruby/1.9.1/fileutils.rb:247 - File exists - .

=> ["a/b/c/d"]

It the most annoying warning, and | always end-up writing my own method instead.

Ah, | see, this is due to the exception-driven implementation of FileUtils.
| think it would be worth discussing it in a separate issue.

#5 - 11/20/2012 06:41 AM - Anonymous

First, let me apologize to everyone for expressing opinion, while having relatively little experience. | like your proposal, but | am concerned about
feature creep. Maybe those convenience features should go to stdlib, just like eg. require 'mathn' changes math behavior, we could have require
'fileboost' or something making FileUtils fatter. | think that in the future, there will be many amazing proposals for FileUtils functionality, like yours here,
so the best of them could go to this 'fileboost' or whatever other name would it have.

#6 - 11/24/2012 11:18 AM - mame (Yusuke Endoh)
- Status changed from Open to Assigned
- Assignee set to matz (Yukihiro Matsumoto)

- Target version set to 2.6

#7 - 12/25/2017 06:15 PM - naruse (Yui NARUSE)
- Target version deleted (2.6)
